
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Counter3 is
    Port ( Clk,CLEAR,up_DOWN,LOAD : in  STD_LOGIC;
           Ld : out  STD_LOGIC_VECTOR (7 downto 0);
           Sw : in  STD_LOGIC_VECTOR (7 downto 0));
end Counter3;

architecture Behavioral of Counter3 is
   -- signal Q: STD_LOGIC_VECTOR (7 downto 0);
begin

   process( Clk,CLEAR)
	   variable Q: STD_LOGIC_VECTOR (7 downto 0);
	begin
	   if CLEAR='1' then
			Q:= "00000000";
		elsif Rising_edge( Clk) then
			if LOAD='1' then
				Q := Sw;
			elsif up_DOWN='0' then
			   Q := Q+1;
			else
			   Q := Q-1;
			end if;
		end if;
		Ld <= Q;
	end process;

end Behavioral;

